package com.bzd.web.controller.ddgl;

import com.bzd.common.annotation.Log;
import com.bzd.common.config.dao.PageData;
import com.bzd.common.core.controller.BaseController;
import com.bzd.common.core.domain.AjaxResult;
import com.bzd.common.core.page.TableDataInfo;
import com.bzd.common.enums.BusinessType;
import com.bzd.system.service.PharmaceuticalService;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.*;
import com.bzd.system.service.ddgl.SDdglFpglInvoiceinfoService;

import java.util.List;

/**
*
* 发票管理表(开发票，发票查询) 前端控制器Controller
* @author LiXiangFei
* @since 2024-10-15
*/
@Controller
@RequestMapping(value = "ddgl/sddglfpglinvoiceinfo")
public class SDdglFpglInvoiceinfoController extends BaseController {

    // 页面跳转前缀
    private String prefix = "ddgl";

    @Autowired
    private SDdglFpglInvoiceinfoService sDdglFpglInvoiceinfoService;

    /**
    * 发票管理表(开发票，发票查询) 新增页面跳转
    *
    * @return
    */
    @RequiresPermissions("ddgl:dd:view")
    @GetMapping("/sDdglFpglInvoiceinfoAdd")
    public String add() {
        return prefix + "/SDdglFpglInvoiceinfoAdd";
    }

    /**
    * 发票管理表(开发票，发票查询) 新增
    *
    * @return
    */
    @Log(title = "发票管理表(开发票，发票查询)新增", businessType = BusinessType.INSERT)
    @PostMapping("/sDdglFpglInvoiceinfoAdd")
    @ResponseBody
    public AjaxResult addSave() throws Exception {
        PageData pd = this.getPageData();
        try {
            Integer result = sDdglFpglInvoiceinfoService.addSDdglFpglInvoiceinfo(pd);
            if (result == 1) {
                return AjaxResult.success("新增成功");
            } else {
                logger.error("Failed to update 表skccrkckreceiptinfo with ID: {}", pd.get("id"));
                return AjaxResult.error("新增失败");
            }
        } catch (Exception e) {
            logger.error("Error occurred while updating 表skccrkckreceiptinfo with ID: {}, Exception: {}", pd.get("id"), e.getMessage(), e);
            return AjaxResult.error("系统异常：" + e.getMessage());
        }
    }

    /**
    * 发票管理表(开发票，发票查询) 查询页面跳转
    *
    * @return
    */
    @RequiresPermissions("ddgl:dd:view")
    @GetMapping("/sDdglFpglInvoiceinfoView")
    public String sddglfpglinvoiceinfoListView() {
        return prefix + "/SDdglFpglInvoiceinfoList";
    }

    /**
    * 发票管理表(开发票，发票查询) 数据查询
    *
    * @return
    * @throws Exception
    */
    @RequiresPermissions("ddgl:dd:sDdglFpglInvoiceinfoList")
    @PostMapping("/sDdglFpglInvoiceinfoList")
    @ResponseBody
    public TableDataInfo sddglfpglinvoiceinfoList() throws Exception {
    PageData pd = this.getPageData();
    startPage();
    List<PageData> pageData = sDdglFpglInvoiceinfoService.findSDdglFpglInvoiceinfoList(pd);
        return getDataTable(pageData);
    }

    /**
    * 发票管理表(开发票，发票查询) 数据删除 根据id
    *
    * @return
    * @throws Exception
    */
    @RequiresPermissions("ddgl:dd:remove")
    @Log(title = "发票管理表(开发票，发票查询)删除", businessType = BusinessType.DELETE)
    @PostMapping("/sDdglFpglInvoiceinfoRemove")
    @ResponseBody
    public AjaxResult sddglfpglinvoiceinfoRemove() throws Exception {
        PageData pd = this.getPageData();
        Integer integer = sDdglFpglInvoiceinfoService.SDdglFpglInvoiceinfoRemove(pd);
        return toAjax(integer);
    }

    /**
    * 发票管理表(开发票，发票查询) 数据修改
    *
    * @return
    * @throws Exception
    */
    @RequiresPermissions("ddgl:dd:edit")
    @GetMapping("/sDdglFpglInvoiceinfoEdit/{id}")
    public String sddglfpglinvoiceinfoView(@PathVariable("id") Long id, ModelMap mmap) throws Exception {
        PageData pd = this.getPageData();
        pd.put("id", id);
        PageData pageData = sDdglFpglInvoiceinfoService.findSDdglFpglInvoiceinfoList(pd).get(0);
        mmap.putAll(pageData);
        if(null!=pd.getString("status")){
            return prefix+ "/sddglfpglinvoiceinfoPageEdit";
        }
        return prefix+ "/sddglfpglinvoiceinfoEdit";
    }

    /**
    * 发票管理表(开发票，发票查询)保存修改的数据
    */
    @RequiresPermissions("ddgl:dd:edit")
    @Log(title = "发票管理表(开发票，发票查询)修改", businessType = BusinessType.UPDATE)
    @PostMapping("/sDdglFpglInvoiceinfoEdit")
    @ResponseBody
    public AjaxResult sddglfpglinvoiceinfoEditSave() throws Exception {
        PageData pd = this.getPageData();
        pd.put("up", "up");
        try {
            Integer updateResult = sDdglFpglInvoiceinfoService.updateSDdglFpglInvoiceinfo(pd);
            if (updateResult == 1) {
                // 成功更新
                return AjaxResult.success("修改成功");
            } else {
                // 更新失败
                logger.error("Failed to update 表sddglfpglinvoiceinfo with ID: {}", pd.get("id"));
                return AjaxResult.error("修改失败");
            }
        } catch (Exception e) {
            // 异常处理
            logger.error("Error occurred while updating 表sddglfpglinvoiceinfo with ID: {}, Exception: {}", pd.get("id"), e.getMessage(), e);
            return AjaxResult.error("系统异常：" + e.getMessage());
        }
    }
}
